program mynormal14, properties(swml)
        version 18
        if replay() {
                if (`"`e(cmd)'"' != "mynormal14") error 301
                Replay `0'
        }
        else    Estimate `0'
end

program Estimate, eclass sortpreserve

        syntax varlist(fv) [if] [in]                    ///
                        [fweight pweight iweight] [,    ///
			noLOG                           ///
			noCONStant			///
                        vce(passthru)                   ///
                        FROM(string)                    ///
                        CONSTraints(string)             /// 
                        *                               ///
                ]

        // Mark estimation sample
        marksample touse  

        // check syntax
        mlopts mlopts other, `options'
	// parse Replay options
	_get_diopts diopts, `other'
        gettoken lhs rhs : varlist
        _fv_check_depvar `lhs'
        
        _vce_parse `touse', opt(Robust oim opg) argopt(CLuster): `wgt', `vce'
        local vcespec  `r(vce)'
        local vceclust `r(cluster)'

        // Build coefficient column stripe, accounting for 
        local mueq  
	fvexpand `rhs'
	local rhs_list = r(varlist)
        foreach v in `rhs_list' {
                local mueq `mueq' mu:`v'
        }
        if "`constant'" == "" {
                local mueq `mueq' mu:_cons
        }
        local lseq /:lnsigma
        local alleq `mueq' `lseq'

        // _mkvec wants the full coefficient vector, but moptimize()
        // requires us to initialize each param. separately.
        tempname b0 b0_1 b0_2
        _mkvec `b0', from(`from') colnames(`alleq')
        matrix `b0_1' = `b0'[1, "mu:"]
        matrix `b0_2' = `b0'[1, "/:"]

        // Now that we have a coefficient vector with a column stripe,
        // we can parse constraints if any.
        if "`constraints'" != "" {
                tempname C V
                        // To post we need V too
                matrix `V' = `b0''*`b0'
                        // A dummy solution
                ereturn post `b0' `V'
                makecns `constraints'
                matrix `C' = e(Cns)
        }
	
	// This will hold the maximized log-likelihood value
	tempname ll
        mata: myMataRegress("`lhs'",      "`rhs'",      "`touse'",    ///
                            "`constant'", "`weight'",   "`wtvar'",    ///
                            "`vcespec'",  "`vceclust'", "`mlopts'",   ///
                            "`b0_1'",     "`b0_2'",     "`C'",        ///
                            "`log'",      "`ll'") 

        ereturn scalar ll = `ll'
        ereturn local predict mynormal_p
        ereturn local cmd mynormal14

        Replay , `diopts'
end

program Replay
 
        syntax [, *] 
        ml display , `options' diparm(/lnsigma, exp label("sigma")) 
	
end

	// This allows us to type `SS' rather than string scalar
	// when we declare string scalar variables.
local SS string scalar

mata:
mata set matastrict on

void mynormal_lf(transmorphic scalar ML, real rowvector b, 
                 real colvector lnfj)
{
    real scalar lnsigma
    real vector depvar, xb

    depvar  = moptimize_util_depvar(ML, 1)
    xb      = moptimize_util_xb(ML, b, 1)
    lnsigma = moptimize_util_xb(ML, b, 2)
    
    lnfj    = ln(normalden(depvar, xb, exp(lnsigma)))
}

void myMataRegress(`SS' lhs,         `SS' rhs,        `SS' touse,
                   `SS' noconst,     `SS' weight,     `SS' wtvar,
                   `SS' vcespec,     `SS' vceclust,   `SS' mlopts,
                   `SS' b0_1,        `SS' b0_2,       `SS' Cmat,
                   `SS' logopt,      `SS' lltemp) {

        transmorphic scalar ML
    
        ML = moptimize_init()
        moptimize_init_which(ML, "max")
        moptimize_init_evaluator(ML, &mynormal_lf())
        moptimize_init_evaluatortype(ML, "lf")
        moptimize_init_mlopts(ML, mlopts)
        moptimize_init_valueid(ML, "Log likelihood")
    
        moptimize_init_touse(ML, touse)
        moptimize_init_depvar(ML, 1, lhs)
        moptimize_init_eq_indepvars(ML, 1, rhs)
        if (noconst != "") {
                moptimize_init_eq_cons(ML, 1, "off")
        }
        moptimize_init_eq_indepvars(ML, 2, "")
        moptimize_init_eq_freeparm(ML, 2, "on")
        moptimize_init_eq_coefs(ML, 1, st_matrix(b0_1))
        moptimize_init_eq_coefs(ML, 2, st_matrix(b0_2))
    
        moptimize_init_eq_name(ML, 1, "mu")
        moptimize_init_eq_name(ML, 2, "lnsigma")
    
        if (wtvar != "") {
                moptimize_init_weighttype(ML, weight)
                moptimize_init_weight(ML, wtvar)
        }
        
        if (vceclust != "") {
                moptimize_init_cluster(ML, vceclust)
        }
        else if (vcespec != "") {
                moptimize_init_vcetype(ML, vcespec)
        } 

        if (Cmat != "") {
                moptimize_init_constraints(ML, st_matrix(Cmat))
        }
        
        if (logopt != "") {
                moptimize_init_tracelevel(ML, "none")
        }
    
        moptimize(ML)
                // We changed the vcetype above, so we
                // don't need to specify vcetype here.
        moptimize_result_post(ML)
                // Store the value of the log-likelihood function
        st_numscalar(lltemp, moptimize_result_value(ML))

}
end
exit

